
--------------------------------------------------------------------------------
-- Company: Corrsys 3D Sensors AG
-- Engineer: Boris Metka
--
-- Create Date:   17:41:52 07/08/2008
-- Design Name:   top_level
-- Module Name:   C:/Dokumente und Einstellungen/bmetka/Desktop/Xilinx-ISE/Frequenzgenerator/Frequenzgenerator/top_level_tb.vhd
-- Project Name:  Frequenzgenerator
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: top_level
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY top_level_tb_vhd IS
END top_level_tb_vhd;

ARCHITECTURE behavior OF top_level_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT top_level
	PORT(
		Data_IN : INOUT std_logic_vector(7 downto 0);
		CLK : IN std_logic;
		TXE : IN std_logic;
		RXF : IN std_logic;
		PWREN : IN std_logic;          
		Data_OUT : OUT std_logic_vector(7 downto 0);
		RD : OUT std_logic;
		WR : OUT std_logic;
		W_CLK : OUT std_logic_vector(3 downto 0);
		RESET : OUT std_logic;
		FQ_UD : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL CLK :  std_logic := '0';
	SIGNAL TXE :  std_logic := '0';
	SIGNAL RXF :  std_logic := '0';
	SIGNAL PWREN :  std_logic := '0';
	SIGNAL Data_IN :  std_logic_vector(7 downto 0) := (others=>'0');

	--Outputs
	SIGNAL Data_OUT :  std_logic_vector(7 downto 0);
	SIGNAL RD :  std_logic;
	SIGNAL WR :  std_logic;
	SIGNAL W_CLK :  std_logic_vector(3 downto 0);
	SIGNAL RESET :  std_logic;
	SIGNAL FQ_UD :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: top_level PORT MAP(
		Data_IN => Data_IN,
		Data_OUT => Data_OUT,
		CLK => CLK,
		RD => RD,
		WR => WR,
		TXE => TXE,
		RXF => RXF,
		PWREN => PWREN,
		W_CLK => W_CLK,
		RESET => RESET,
		FQ_UD => FQ_UD
	);

	clk_tb : PROCESS
	BEGIN
		loop
		clk <= '0';
		wait for 25 ns;
		clk <= '1';
		wait for 25 ns;
		end loop;
	END PROCESS;
	
	rxf_tb : PROCESS
	BEGIN
		RXF <= '1';
		wait for 50 ns;
		RXF <= '0';
		wait for 9 us;
		RXF <= '1';
		wait for 150 ns;
	END PROCESS;
	
	Data_IN_tb  : PROCESS (RD)
	variable counter : std_logic_vector(7 downto 0) := X"00" ;
	BEGIN
		if RD = '1' and RXF = '0' then
			Data_IN <= "ZZZZZZZZ" after 5 ns;
		elsif RD = '0' and RXF = '0' then
			counter := counter + '1' ;
			case counter is
			-- Reset
			when x"01" => Data_IN <= X"DF" after 5 ns;
			-- Sync
			when x"02" => Data_IN <= X"1F" after 5 ns;
			
			-- erster Durchlauf
			-- Sync fr ersten DDS
			when x"03" => Data_IN <= X"01" after 5 ns;
			
			when x"04" => Data_IN <= X"00" after 5 ns;
			when x"05" => Data_IN <= X"00" after 5 ns;
			when x"06" => Data_IN <= X"09" after 5 ns;
			when x"07" => Data_IN <= X"52" after 5 ns;
			when x"08" => Data_IN <= X"EF" after 5 ns;
			
--			when x"09" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr zweiten DDS
--			when x"0A" => Data_IN <= X"2F" after 5 ns;
--			
--			when x"0B" => Data_IN <= X"B1" after 5 ns;
--			when x"0C" => Data_IN <= X"B2" after 5 ns;
--			when x"0D" => Data_IN <= X"B3" after 5 ns;
--			when x"0E" => Data_IN <= X"B4" after 5 ns;
--			when x"0F" => Data_IN <= X"B5" after 5 ns;
--			
--			when x"10" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr dritten DDS
--			when x"11" => Data_IN <= X"3F" after 5 ns;
--			
--			when x"12" => Data_IN <= X"C1" after 5 ns;
--			when x"13" => Data_IN <= X"C2" after 5 ns;
--			when x"14" => Data_IN <= X"C3" after 5 ns;
--			when x"15" => Data_IN <= X"C4" after 5 ns;
--			when x"16" => Data_IN <= X"C5" after 5 ns;
--			
--			when x"17" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr vierten DDS
--			when x"18" => Data_IN <= X"4F" after 5 ns;
--			
--			when x"19" => Data_IN <= X"D1" after 5 ns;
--			when x"1A" => Data_IN <= X"D2" after 5 ns;
--			when x"1B" => Data_IN <= X"D3" after 5 ns;
--			when x"1C" => Data_IN <= X"D4" after 5 ns;
--			when x"1D" => Data_IN <= X"D5" after 5 ns;
--			
--			when x"1E" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Ende erster Durchlauf
--			
--			when x"1F" => Data_IN <= X"9F" after 5 ns;
--			when x"20" => Data_IN <= (others => 'Z') after 5 ns;
--			-- zweiter Durchlauf
--			-- Sync
--			when x"1F" => Data_IN <= X"DF" after 5 ns;
--			
--			-- Sync fr ersten DDS
--			when x"20" => Data_IN <= X"1F" after 5 ns;
--			
--			when x"21" => Data_IN <= X"A1" after 5 ns;
--			when x"22" => Data_IN <= X"A2" after 5 ns;
--			when x"23" => Data_IN <= X"A3" after 5 ns;
--			when x"24" => Data_IN <= X"A4" after 5 ns;
--			when x"25" => Data_IN <= X"A5" after 5 ns;
--			
--			when x"26" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr zweiten DDS
--			when x"27" => Data_IN <= X"2F" after 5 ns;
--			
--			when x"28" => Data_IN <= X"B1" after 5 ns;
--			when x"29" => Data_IN <= X"B2" after 5 ns;
--			when x"2A" => Data_IN <= X"B3" after 5 ns;
--			when x"2B" => Data_IN <= X"B4" after 5 ns;
--			when x"2C" => Data_IN <= X"B5" after 5 ns;
--			
--			when x"2D" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr dritten DDS
--			when x"2E" => Data_IN <= X"3F" after 5 ns;
--			
--			when x"2F" => Data_IN <= X"C1" after 5 ns;
--			when x"30" => Data_IN <= X"C2" after 5 ns;
--			when x"31" => Data_IN <= X"C3" after 5 ns;
--			when x"32" => Data_IN <= X"C4" after 5 ns;
--			when x"33" => Data_IN <= X"C5" after 5 ns;
--			
--			when x"34" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr vierten DDS
--			when x"35" => Data_IN <= X"4F" after 5 ns;
--			
--			when x"36" => Data_IN <= X"D1" after 5 ns;
--			when x"37" => Data_IN <= X"D2" after 5 ns;
--			when x"38" => Data_IN <= X"D3" after 5 ns;
--			when x"39" => Data_IN <= X"D4" after 5 ns;
--			when x"3A" => Data_IN <= X"D5" after 5 ns;
--			
--			when x"3B" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Ende zweiter Durchlauf
--	
--			-- Datenmll
--			when x"3C" => Data_IN <= X"46" after 5 ns;
--			when x"3D" => Data_IN <= X"5C" after 5 ns;
--			when x"3E" => Data_IN <= X"6E" after 5 ns;
--			when x"3F" => Data_IN <= X"D2" after 5 ns;
--			-- Ende Datenmll
--			
--			--dritter Durchlauf
--			-- Sync
--			when x"40" => Data_IN <= X"DF" after 5 ns;
--			
--			-- Sync fr ersten DDS
--			when x"41" => Data_IN <= X"1F" after 5 ns;
--			
--			when x"42" => Data_IN <= X"A1" after 5 ns;
--			when x"43" => Data_IN <= X"A2" after 5 ns;
--			when x"44" => Data_IN <= X"A3" after 5 ns;
--			when x"45" => Data_IN <= X"A4" after 5 ns;
--			when x"46" => Data_IN <= X"A5" after 5 ns;
--			
--			when x"47" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr zweiten DDS
--			when x"48" => Data_IN <= X"2F" after 5 ns;
--			
--			when x"49" => Data_IN <= X"B1" after 5 ns;
--			when x"4A" => Data_IN <= X"B2" after 5 ns;
--			when x"4B" => Data_IN <= X"B3" after 5 ns;
--			when x"4C" => Data_IN <= X"B4" after 5 ns;
--			when x"4D" => Data_IN <= X"B5" after 5 ns;
--			
--			when x"4E" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr dritten DDS
--			when x"4F" => Data_IN <= X"3F" after 5 ns;
--			
--			when x"50" => Data_IN <= X"C1" after 5 ns;
--			when x"51" => Data_IN <= X"C2" after 5 ns;
--			when x"52" => Data_IN <= X"C3" after 5 ns;
--			when x"53" => Data_IN <= X"C4" after 5 ns;
--			when x"54" => Data_IN <= X"C5" after 5 ns;
--			
--			when x"55" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Sync fr vierten DDS
--			when x"56" => Data_IN <= X"4F" after 5 ns;
--			
--			when x"57" => Data_IN <= X"D1" after 5 ns;
--			when x"58" => Data_IN <= X"D2" after 5 ns;
--			when x"59" => Data_IN <= X"D3" after 5 ns;
--			when x"5A" => Data_IN <= X"D4" after 5 ns;
--			when x"5B" => Data_IN <= X"D5" after 5 ns;
--			
--			when x"5C" => Data_IN <= X"EF" after 5 ns;
--			
--			-- Ende dritterlauf
--			
--			-- "Datenmll"
--			when x"5D" => Data_IN <= X"EE" after 5 ns;
--			when x"5E" => Data_IN <= X"CC" after 5 ns;
			
			-- Alternative
			when others => Data_IN <= X"00";
			
			end case;
			--else Data_IN <= 'Z';
			end if;
	END PROCESS;
	
	txe_tb : PROCESS
	BEGIN
		txe <= '1';
		wait for 3400 ns;
		txe <= '0';
		wait for 34500 ns;
		txe <= '1';
		wait for 1000 ns;
	END PROCESS;



END;
